"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresConnection = void 0;
var tslib_1 = require("tslib");
var pg_1 = tslib_1.__importDefault(require("pg"));
var PostgresConnection = /** @class */ (function () {
    function PostgresConnection(dbUrl, sessionStorageIdentifier) {
        this.ready = this.init(dbUrl);
        this.sessionStorageIdentifier = sessionStorageIdentifier;
    }
    PostgresConnection.prototype.query = function (query, params) {
        if (params === void 0) { params = []; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ready];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.client.query(query, params)];
                    case 2: return [2 /*return*/, (_a.sent()).rows];
                }
            });
        });
    };
    PostgresConnection.prototype.disconnect = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ready];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.client.end()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PostgresConnection.prototype.connect = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ready];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.client.connect()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PostgresConnection.prototype.getDatabase = function () {
        return this.client.database;
    };
    PostgresConnection.prototype.hasTable = function (tablename) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var query, rows;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ready];
                    case 1:
                        _a.sent();
                        query = "\n      SELECT EXISTS (\n        SELECT tablename FROM pg_catalog.pg_tables \n          WHERE tablename = ".concat(this.getArgumentPlaceholder(1), "\n      )\n  ");
                        return [4 /*yield*/, this.query(query, [tablename])];
                    case 2:
                        rows = _a.sent();
                        return [2 /*return*/, rows[0].exists];
                }
            });
        });
    };
    PostgresConnection.prototype.getArgumentPlaceholder = function (position) {
        return "$".concat(position);
    };
    PostgresConnection.prototype.init = function (dbUrl) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.client = new pg_1.default.Client({ connectionString: dbUrl.toString() });
                return [2 /*return*/];
            });
        });
    };
    return PostgresConnection;
}());
exports.PostgresConnection = PostgresConnection;
//# sourceMappingURL=postgres-connection.js.map